﻿using Benner.Corporativo.TestesInterface.ArquivosDeDados.Usuarios;
using Benner.Corporativo.TestesInterface.Mapeamento.Usuarios;
using Benner.Tecnologia.Wes.UITests;
using NUnit.Framework;
using OpenQA.Selenium;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Benner.Corporativo.TestesInterface.CasosDeTestes.Usuarios
{
    public class CT_Usuarios : CT_Register
    {
        private const string NOME_GRID = "GRIDWIDGET_635839538346570987";
        private const string NOME_FORM = "USUARIO";

        [Test, Order(1)]
        [TestCase(FormUsuarios.idTest01, TestName = FormUsuarios.casoTeste01)]
        public void InserirUsuariosTest(string idTest)
        {
            Relatorio.IniciarTeste(idTest);

            DadosUsuarios dadosXLS = GetDados(idTest);

            GenericCrud<DadosUsuarios, FormUsuarios>(dadosXLS, NOME_GRID, NOME_FORM, "", "Inserir", "", "");

            Relatorio.EncerrarTeste();
        }

        [Test, Order(2)]
        [TestCase(FormUsuarios.idTest02, TestName = FormUsuarios.casoTeste02)]
        public void ExcluirUsuariosTest(string idTest)
        {
            Relatorio.IniciarTeste(idTest);

            DadosUsuarios dadosXLS = GetDados(idTest);

            GenericCrud<DadosUsuarios, FormUsuarios>(dadosXLS, NOME_GRID, NOME_FORM, dadosXLS.Apelido, "Excluir", "", "");

            Relatorio.EncerrarTeste();
        }

        private DadosUsuarios GetDados(string idTest)
        {
            DadosUsuarios dadosXLS = Dados.CarregarDeXls<DadosUsuarios>(DadosUsuarios.CaminhoXLS, idTest);
            InicializaConfigTest<DadosUsuarios>(dadosXLS);

            AlternarEmpresaFilial(dadosXLS.Empresa, dadosXLS.Filial);

            Menu.Principal.Item("Configurações").Clicar();

            driver.FindElement(By.LinkText("Usuários")).Clicar();
            Pagina.AguardarCarregamento();

            return dadosXLS;
        }
    }
}